<template>
    <div class="row">
      <div class="col-12">
        <card>
        <div class="card-header d-flex mb-3" style="justify-content: space-between;">
          <h4 class="card-title">Lista de clientes</h4>
        </div>

          <div class="d-inline-flex mb-4" style="align-items: flex-end;float: right;">
            <div class="col-md-5 pl-md-1">
              <label class="control-label">Filtro: Status</label>
              <select class="form-control" v-model="filters.contractStatus">
                <option style="color: black;" value="">Todos</option>
                <option 
                  style="color: black;" 
                  class="text-capitalize"
                  v-for="(label, status) in states" :value="status"
                >{{label}}</option>
              </select>
            </div>

            <div>
              <base-button type="primary" size="md" @click="goToCreateCustomerPage()" style="margin: 0;">
                Adicionar novo
              </base-button>
            </div>
          </div>

          <div class="table-responsive">
            <base-table :data="table1.data" :columns="table1.columns">
              <template slot="columns">
                <th>Nome</th>
                <th>CPF/CNPJ</th>
                <th>Numero do contrato</th>
                <th>Situação do contrato</th>
                <th>Ações</th>
              </template>  

              <template slot-scope="{row}">
                <td class="text-capitalize">{{row.name}}</td>
                <td>{{row.document | formataCPF}}</td>
                <td>{{row.contractNumber}}</td>
                <td class="text-capitalize">{{row.contractStatus | statusLabel}}</td>

                <td class="td-actions">
                  <base-button type="success" size="sm" icon class="mr-2" @click="view(row.id)">
                    <i class="tim-icons icon-settings"></i>
                  </base-button>

                  <base-button type="danger" size="sm" icon  @click="remove(row.id)">
                    <i class="tim-icons icon-simple-remove"></i>
                  </base-button>
                </td>

              </template>    
            </base-table>
          </div>
        </card>
      </div>
    </div>
</template>
<script>

import { BaseTable } from "@/components";
import CustomerDataService from "../services/CustomerDataService";
import { states, getStatusLabel } from "../utils/contractStatus";

const tableColumns = ["Nome", "Document", "ContractNumber", "ContractStatus"];

export default {
  components: {
    BaseTable
  },
  data() {
    return {
      table1: {
        title: "Lista de clientes",
        columns: [...tableColumns],
        data: []
      },
      filters: {
        contractStatus: '',
      },
      states
    };
  },
  watch: {
    'filters.contractStatus': function (val, oldVal){
        this.getAll()
    },
  },
  methods: {
    goToCreateCustomerPage() {
      this.$router.push({ path: '/customer/create'})
    },
    notificate(message, type = 'success') {
        this.$notify({ verticalAlign: 'top', horizontalAlign: 'center', message, type });
    },
    getAll() {
     CustomerDataService.getAll(this.filters)
       .then(response => {  
          this.table1.data = response.data.results;
       })
       .catch(e => {
        this.notificate('Oops! Ocorreu um erro inesperado.', 'danger');
       });
    },
    async remove(id) {
      let confirmation = confirm("Deseja realmente excluir este cliente ?");
      
      if (!confirmation) return;

      CustomerDataService.delete(id)
        .then(response => {
          this.notificate('Cliente deletado com sucesso!');
          this.getAll();
        })
        .catch(e => {
          this.notificate('Oops! Ocorreu um erro inesperado.', 'danger');
        })

      this.getAll()
    },
    view(id) {
      this.$router.push({ name: "customer-edit", params: { id: id} })
    }
  },
  filters: {
      formataCPF(cpf){
        cpf = cpf.replace(/[^\d]/g, "");
        
        return cpf.replace(/(\d{3})(\d{3})(\d{3})(\d{2})/, "$1.$2.$3-$4");
      },
      statusLabel(status) {
        return getStatusLabel(status);
      }
  },
  mounted() {
    this.getAll();
  }
};
</script>